// Code generated by github.com/atombender/go-jsonschema, DO NOT EDIT.

package payloads

import "fmt"
import "encoding/json"

type BerlinSearchSchemaJson struct {
	// Query corresponds to the JSON schema field "query".
	Query SearchTermJson `json:"query"`

	// Results corresponds to the JSON schema field "results".
	Results []SearchResult `json:"results"`

	// Time corresponds to the JSON schema field "time".
	Time string `json:"time"`
}

// UnmarshalJSON implements json.Unmarshaler.
func (j *LocJson) UnmarshalJSON(b []byte) error {
	var raw map[string]interface{}
	if err := json.Unmarshal(b, &raw); err != nil {
		return err
	}
	if v, ok := raw["codes"]; !ok || v == nil {
		return fmt.Errorf("field codes: required")
	}
	if v, ok := raw["encoding"]; !ok || v == nil {
		return fmt.Errorf("field encoding: required")
	}
	if v, ok := raw["id"]; !ok || v == nil {
		return fmt.Errorf("field id: required")
	}
	if v, ok := raw["key"]; !ok || v == nil {
		return fmt.Errorf("field key: required")
	}
	if v, ok := raw["names"]; !ok || v == nil {
		return fmt.Errorf("field names: required")
	}
	if v, ok := raw["state"]; !ok || v == nil {
		return fmt.Errorf("field state: required")
	}
	type Plain LocJson
	var plain Plain
	if err := json.Unmarshal(b, &plain); err != nil {
		return err
	}
	*j = LocJson(plain)
	return nil
}

type SearchResult struct {
	// Loc corresponds to the JSON schema field "loc".
	Loc LocJson `json:"loc"`

	// Score corresponds to the JSON schema field "score".
	Score int `json:"score"`
}

// UnmarshalJSON implements json.Unmarshaler.
func (j *SearchResult) UnmarshalJSON(b []byte) error {
	var raw map[string]interface{}
	if err := json.Unmarshal(b, &raw); err != nil {
		return err
	}
	if v, ok := raw["loc"]; !ok || v == nil {
		return fmt.Errorf("field loc: required")
	}
	if v, ok := raw["score"]; !ok || v == nil {
		return fmt.Errorf("field score: required")
	}
	type Plain SearchResult
	var plain Plain
	if err := json.Unmarshal(b, &plain); err != nil {
		return err
	}
	*j = SearchResult(plain)
	return nil
}

type SearchTermJson struct {
	// Codes corresponds to the JSON schema field "codes".
	Codes []string `json:"codes"`

	// ExactMatches corresponds to the JSON schema field "exact_matches".
	ExactMatches []string `json:"exact_matches"`

	// Normalized corresponds to the JSON schema field "normalized".
	Normalized string `json:"normalized"`

	// NotExactMatches corresponds to the JSON schema field "not_exact_matches".
	NotExactMatches []string `json:"not_exact_matches"`

	// Raw corresponds to the JSON schema field "raw".
	Raw string `json:"raw"`

	// StateFilter corresponds to the JSON schema field "state_filter".
	StateFilter interface{} `json:"state_filter,omitempty"`

	// StopWords corresponds to the JSON schema field "stop_words".
	StopWords []string `json:"stop_words"`
}

// UnmarshalJSON implements json.Unmarshaler.
func (j *SearchTermJson) UnmarshalJSON(b []byte) error {
	var raw map[string]interface{}
	if err := json.Unmarshal(b, &raw); err != nil {
		return err
	}
	if v, ok := raw["codes"]; !ok || v == nil {
		return fmt.Errorf("field codes: required")
	}
	if v, ok := raw["exact_matches"]; !ok || v == nil {
		return fmt.Errorf("field exact_matches: required")
	}
	if v, ok := raw["normalized"]; !ok || v == nil {
		return fmt.Errorf("field normalized: required")
	}
	if v, ok := raw["not_exact_matches"]; !ok || v == nil {
		return fmt.Errorf("field not_exact_matches: required")
	}
	if v, ok := raw["raw"]; !ok || v == nil {
		return fmt.Errorf("field raw: required")
	}
	if v, ok := raw["stop_words"]; !ok || v == nil {
		return fmt.Errorf("field stop_words: required")
	}
	type Plain SearchTermJson
	var plain Plain
	if err := json.Unmarshal(b, &plain); err != nil {
		return err
	}
	*j = SearchTermJson(plain)
	return nil
}

type LocJson struct {
	// Codes corresponds to the JSON schema field "codes".
	Codes []string `json:"codes"`

	// Encoding corresponds to the JSON schema field "encoding".
	Encoding string `json:"encoding"`

	// Id corresponds to the JSON schema field "id".
	Id string `json:"id"`

	// Key corresponds to the JSON schema field "key".
	Key string `json:"key"`

	// Names corresponds to the JSON schema field "names".
	Names []string `json:"names"`

	// State corresponds to the JSON schema field "state".
	State []string `json:"state"`

	// Subdiv corresponds to the JSON schema field "subdiv".
	Subdiv interface{} `json:"subdiv,omitempty"`
}

// UnmarshalJSON implements json.Unmarshaler.
func (j *BerlinSearchSchemaJson) UnmarshalJSON(b []byte) error {
	var raw map[string]interface{}
	if err := json.Unmarshal(b, &raw); err != nil {
		return err
	}
	if v, ok := raw["query"]; !ok || v == nil {
		return fmt.Errorf("field query: required")
	}
	if v, ok := raw["results"]; !ok || v == nil {
		return fmt.Errorf("field results: required")
	}
	if v, ok := raw["time"]; !ok || v == nil {
		return fmt.Errorf("field time: required")
	}
	type Plain BerlinSearchSchemaJson
	var plain Plain
	if err := json.Unmarshal(b, &plain); err != nil {
		return err
	}
	*j = BerlinSearchSchemaJson(plain)
	return nil
}
